uses
	testlib, sysutils;
const
	maxn = 100;
	maxm = 100;
var
	a: array [1..maxn] of longint;
	c: array [1..maxn, 1..maxm] of longint;
	n, m, i, j, k: longint;
	ja, pa, pc: longint;
	cur, cl: longint;
begin
	ja := ans.readlongint;

	pa := ouf.readlongint;

	n := inf.readlongint;
	m := inf.readlongint;
	for i := 1 to m do 
		a[i] := inf.readlongint;

	for i := 1 to m do begin
		for j := 1 to n do begin
			c[j][i] := inf.readlongint;
		end;
	end;

	pc := 0;
	cur := 0;
	cl := 0;
	for i := 1 to n do begin
		j := ouf.readlongint;
		if (j < 1) or (j > m) then
			quit(_wa, format('invalid student number: %d', [j]));
		if cur <> j then begin
			cur := j;
			cl := 1;
		end else begin
			inc(cl);
		end;
		pc := pc + c[i][j];
		if cl > a[cur] then
			quit(_wa, format('student %d does not agree to do hometask for %d days in a row', [j, cl]));
	end;

	if pc <> pa then
		quit(_wa, format('promised: %d, calculated: %d', [pa, pc]));

	if ja < pa then
		quit(_wa, format('expected: %d, found: %d', [ja, pa]));
	if ja > pa then
		quit(_fail, format('expected: %d, found: %d', [ja, pa]));

	quit(_ok, format('%d', [ja]));
end.